$(() => {
let popup;
let form;
let showConflictError = false;
let overlappingRule = 'sameResource';
const scheduler = $('#scheduler').dxScheduler({
dataSource: data,
views: ['day', 'week', 'workWeek', 'month'],
currentView: 'week',
currentDate: new Date(2026, 1, 10),
startDayHour: 9,
endDayHour: 19,
height: 600,
showAllDayPanel: false,
allDayPanelMode: 'hidden',
resources: [{
fieldExpr: 'assigneeId',
dataSource: assignees,
valueExpr: 'id',
colorExpr: 'color',
icon: 'user',
allowMultiple: true,
}],
editing: {
popup: {
onInitialized: (e) => {
popup = e.component;
},
onHidden: () => {
setConflictError(false);
},
},
form: {
labelMode: 'hidden',
elementAttr: { class: 'hide-informer', id: 'form' },
onInitialized: (e) => {
form = e.component;
form.on('fieldDataChanged', (e) => {
if (showConflictError && ['startDate', 'endDate', 'assigneeId', 'recurrenceRule'].includes(e.dataField)) {
setConflictError(false);
form.validate();
}
});
},
items: [
{
name: 'conflictInformer',
template: () => $('<div>')
.addClass('conflict-informer')
.text('This time slot conflicts with another appointment.'),
},
{
name: 'mainGroup',
items: [
'subjectGroup',
'dateGroup',
'repeatGroup',
{
name: 'assigneeIdGroup',
items: [
'assigneeIdIcon',
{
name: 'assigneeIdEditor',
isRequired: true,
editorOptions: {
onValueChanged: (e) => {
if (e.value.length > 1) {
e.component.option('value', [e.value[e.value.length - 1]]);
}
},
tagTemplate: (tagData) => $('<div />')
.css('background-color', tagData.color)
.css('border-color', tagData.color)
.addClass('dx-tag-content')
.append(
$('<span />').text(tagData.text),
$('<div />').addClass('dx-tag-remove-button'),
),
},
},
],
},
],
},
'recurrenceGroup',
],
customizeItem: (item) => {
if (item.name === 'allDayEditor' || item.name === 'recurrenceEndEditor') {
item.label.visible = true;
} else if (item.name === 'subjectEditor') {
item.editorOptions.placeholder = 'Add title';
}
if (item.name === 'startTimeEditor' || item.name === 'endTimeEditor') {
item.validationRules = [
{ type: 'required' },
{
type: 'custom',
message: 'Time conflict',
ignoreEmptyValue: true,
reevaluate: true,
validationCallback: () => !showConflictError,
},
];
}
},
},
},
onAppointmentAdding(e) {
handleConflict(e, e.appointmentData);
},
onAppointmentUpdating(e) {
handleConflict(e, e.newData);
},
}).dxScheduler('instance');
function setConflictError(show) {
showConflictError = show;
form?.option('elementAttr.class', show ? '' : 'hide-informer');
}
function handleConflict(e, appointmentData) {
if (!detectConflict(appointmentData)) {
setConflictError(false);
return;
}
e.cancel = true;
if (popup?.option('visible')) {
setConflictError(true);
form.validate();
} else {
const dialog = DevExpress.ui.dialog.custom({
showTitle: false,
messageHtml: '<p id="conflict-dialog">This time slot conflicts with another appointment.</p>',
buttons: [{
type: 'default',
text: 'Close',
stylingMode: 'contained',
onClick: () => {
dialog.hide();
},
}],
});
dialog.show();
}
}
function getNextDay(date) {
const next = new Date(date);
next.setDate(next.getDate() + 1);
return next;
}
function getEndDate(occurrence) {
return occurrence.appointmentData.allDay
? getNextDay(occurrence.startDate)
: occurrence.endDate;
}
function isOverlapping(a, b) {
const aEnd = getEndDate(a);
const bEnd = getEndDate(b);
if (a.startDate >= bEnd || b.startDate >= aEnd) return false;
if (overlappingRule === 'sameResource') {
return a.appointmentData.assigneeId[0] === b.appointmentData.assigneeId[0];
}
return true;
}
function detectConflict(newAppointment) {
const allAppointments = scheduler.getDataSource().items();
const startDate = new Date(newAppointment.startDate);
let endDate;
if (newAppointment.recurrenceRule) {
endDate = scheduler.getEndViewDate();
} else if (newAppointment.allDay) {
endDate = getNextDay(startDate);
} else {
endDate = new Date(newAppointment.endDate);
}
const existingOccurrences = scheduler
.getOccurrences(startDate, endDate, allAppointments)
.filter((occurrence) => occurrence.appointmentData.id !== newAppointment.id);
const newOccurrences = scheduler.getOccurrences(startDate, endDate, [newAppointment]);
return newOccurrences.some((newOccurrence) =>
existingOccurrences.some((existingOccurrence) =>
isOverlapping(newOccurrence, existingOccurrence),
),
);
}
$('#overlapping-rule').dxSelectBox({
items: [
{ value: 'sameResource', text: 'Different Resources' },
{ value: 'allResources', text: 'Never' },
],
valueExpr: 'value',
displayExpr: 'text',
value: 'sameResource',
onValueChanged(e) {
overlappingRule = e.value;
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="scheduler"></div>
<div class="options">
<div class="option">
<span>Allow Overlapping Appointments</span>
<div id="overlapping-rule"></div>
</div>
</div>
</div>
</body>
</html>
.dx-scheduler-appointment {
color: #242424;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
gap: 10px;
}
.hide-informer .dx-item:has(.conflict-informer) {
display: none !important;
}
.conflict-informer {
background-color: #FCEAE8;
color: #C50F1F;
font-size: 12px;
padding: 0 12px;
height: 36px;
line-height: 36px;
box-sizing: border-box;
margin-bottom: 8px;
}
.dx-dialog:has(#conflict-dialog) .dx-overlay-content {
width: 280px;
}
.dx-dialog:has(#conflict-dialog) .dx-dialog-content {
padding-bottom: 16px;
}
.dx-dialog:has(#conflict-dialog) .dx-dialog-buttons {
padding-top: 0;
padding-bottom: 16px;
}
.dx-dialog:has(#conflict-dialog) .dx-toolbar-center,
.dx-dialog:has(#conflict-dialog) .dx-button {
width: 100%;
}
const assignees = [
{ id: 1, text: 'Samantha Bright', color: '#A7E3A5' },
{ id: 2, text: 'John Heart', color: '#CFE4FA' },
{ id: 3, text: 'Todd Hoffman', color: '#F9E2AE' },
{ id: 4, text: 'Sandra Johnson', color: '#F1BBBC' },
];
const data = [
{
id: 1,
text: 'Website Re-Design Plan',
startDate: new Date(2026, 1, 9, 9, 30),
endDate: new Date(2026, 1, 9, 11, 30),
assigneeId: [2],
},
{
id: 2,
text: 'Install New Router in Dev Room',
startDate: new Date(2026, 1, 9, 14, 30),
endDate: new Date(2026, 1, 9, 15, 30),
assigneeId: [3],
},
{
id: 3,
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date(2026, 1, 10, 10, 0),
endDate: new Date(2026, 1, 10, 11, 0),
assigneeId: [1],
},
{
id: 4,
text: 'Final Budget Review',
startDate: new Date(2026, 1, 10, 12, 0),
endDate: new Date(2026, 1, 10, 13, 35),
assigneeId: [1],
},
{
id: 5,
text: 'Install New Database',
startDate: new Date(2026, 1, 11, 9, 45),
endDate: new Date(2026, 1, 11, 11, 15),
assigneeId: [4],
},
{
id: 6,
text: 'Approve New Online Marketing Strategy',
startDate: new Date(2026, 1, 11, 12, 0),
endDate: new Date(2026, 1, 11, 14, 0),
assigneeId: [2],
},
{
id: 7,
text: 'Prepare 2021 Marketing Plan',
startDate: new Date(2026, 1, 12, 11, 0),
endDate: new Date(2026, 1, 12, 13, 30),
assigneeId: [3],
},
{
id: 8,
text: 'Brochure Design Review',
startDate: new Date(2026, 1, 12, 14, 0),
endDate: new Date(2026, 1, 12, 15, 30),
assigneeId: [2],
},
{
id: 9,
text: 'Create Icons for Website',
startDate: new Date(2026, 1, 13, 10, 0),
endDate: new Date(2026, 1, 13, 11, 30),
assigneeId: [1],
},
{
id: 10,
text: 'Launch New Website',
startDate: new Date(2026, 1, 13, 12, 20),
endDate: new Date(2026, 1, 13, 14, 0),
assigneeId: [4],
},
{
id: 11,
text: 'Upgrade Server Hardware',
startDate: new Date(2026, 1, 13, 14, 30),
endDate: new Date(2026, 1, 13, 16, 0),
assigneeId: [2],
},
];

<template>
<DxScheduler
:data-source="data"
:views="views"
:current-view="'week'"
:current-date="currentDate"
:start-day-hour="9"
:end-day-hour="19"
:height="600"
:show-all-day-panel="false"
all-day-panel-mode="hidden"
@appointment-adding="onAppointmentAdding"
@appointment-updating="onAppointmentUpdating"
>
<DxResource
field-expr="assigneeId"
:data-source="assignees"
value-expr="id"
color-expr="color"
icon="user"
:allow-multiple="true"
/>
<DxEditing :popup="popupOptions">
<DxForm
label-mode="hidden"
:customize-item="customizeItem"
:element-attr="formElementAttr"
@initialized="onFormInitialized"
>
<DxItem
name="conflictInformer"
template="conflict-informer-template"
/>
<DxItem
type="group"
name="mainGroup"
>
<DxItem name="subjectGroup"/>
<DxItem name="dateGroup"/>
<DxItem name="repeatGroup"/>
<DxItem name="assigneeIdGroup">
<DxItem name="assigneeIdIcon"/>
<DxItem
name="assigneeIdEditor"
:is-required="true"
:editor-options="assigneeIdEditorOptions"
/>
</DxItem>
</DxItem>
<DxItem
type="group"
name="recurrenceGroup"
/>
</DxForm>
</DxEditing>
<template #conflict-informer-template>
<div class="conflict-informer">This time slot conflicts with another appointment.</div>
</template>
<template #tagTemplate="{ data: itemData }">
<div
class="dx-tag-content"
:style="{ backgroundColor: itemData.color, borderColor: itemData.color }"
>
{{ itemData.text }}
<div class="dx-tag-remove-button"/>
</div>
</template>
</DxScheduler>
<div class="options">
<div class="option">
<span>Allow Overlapping Appointments</span>
<DxSelectBox
:items="overlappingRuleItems"
value-expr="value"
display-expr="text"
value="sameResource"
@value-changed="onOverlappingRuleChanged"
/>
</div>
</div>
</template>
<script setup lang="ts">
import DxScheduler, {
DxResource,
DxEditing,
DxForm,
DxItem,
type DxSchedulerTypes,
} from 'devextreme-vue/scheduler';
import DxSelectBox, { type DxSelectBoxTypes } from 'devextreme-vue/select-box';
import { custom as customDialog } from 'devextreme/ui/dialog';
import type { DxFormTypes } from 'devextreme-vue/form';
import type { DxTagBoxTypes } from 'devextreme-vue/tag-box';
import type { DxPopupTypes } from 'devextreme-vue/popup';
import { data, assignees, type Appointment } from './data.ts';
type dxScheduler = NonNullable<DxSchedulerTypes.InitializedEvent['component']>;
type dxForm = NonNullable<DxFormTypes.InitializedEvent['component']>;
type dxPopup = NonNullable<DxPopupTypes.InitializedEvent['component']>;
let form: dxForm | undefined;
let popup: dxPopup | undefined;
let showConflictError = false;
let overlappingRule = 'sameResource';
const currentDate = new Date(2026, 1, 10);
const views: DxSchedulerTypes.ViewType[] = ['day', 'week', 'workWeek', 'month'];
const formElementAttr = { class: 'hide-informer', id: 'form' };
const overlappingRuleItems = [
{ value: 'sameResource', text: 'Different Resources' },
{ value: 'allResources', text: 'Never' },
];
function getNextDay(date: Date): Date {
const next = new Date(date);
next.setDate(next.getDate() + 1);
return next;
}
function getEndDate(occurrence: DxSchedulerTypes.Occurrence): Date {
return (occurrence.appointmentData as Appointment).allDay
? getNextDay(occurrence.startDate)
: occurrence.endDate;
}
function isOverlapping(a: DxSchedulerTypes.Occurrence, b: DxSchedulerTypes.Occurrence): boolean {
const aEnd = getEndDate(a);
const bEnd = getEndDate(b);
if (a.startDate >= bEnd || b.startDate >= aEnd) return false;
if (overlappingRule === 'sameResource') {
return (a.appointmentData as Appointment).assigneeId[0] ===
(b.appointmentData as Appointment).assigneeId[0];
}
return true;
}
function detectConflict(scheduler: dxScheduler, newAppointment: Appointment): boolean {
const allAppointments = scheduler.getDataSource().items() as Appointment[];
const startDate = new Date(newAppointment.startDate);
let endDate: Date;
if (newAppointment.recurrenceRule) {
endDate = scheduler.getEndViewDate();
} else if (newAppointment.allDay) {
endDate = getNextDay(startDate);
} else {
endDate = new Date(newAppointment.endDate);
}
const existingOccurrences = scheduler
.getOccurrences(startDate, endDate, allAppointments)
.filter((occurrence) => (occurrence.appointmentData as Appointment).id !== newAppointment.id);
const newOccurrences = scheduler.getOccurrences(startDate, endDate, [newAppointment]);
return newOccurrences.some((newOccurrence) =>
existingOccurrences.some((existingOccurrence) =>
isOverlapping(newOccurrence, existingOccurrence),
),
);
}
const assigneeIdEditorOptions = {
onValueChanged: (e: DxTagBoxTypes.ValueChangedEvent) => {
if (e.value.length > 1) {
e.component.option('value', [e.value[e.value.length - 1]]);
}
},
tagTemplate: 'tagTemplate',
};
function setConflictError(show: boolean) {
showConflictError = show;
form?.option('elementAttr.class', show ? '' : 'hide-informer');
}
const popupOptions = {
onInitialized: (e: DxPopupTypes.InitializedEvent) => {
popup = e.component as dxPopup;
},
onHidden: () => {
setConflictError(false);
},
};
const handleConflict = (
e: DxSchedulerTypes.AppointmentAddingEvent | DxSchedulerTypes.AppointmentUpdatingEvent,
appointmentData: Appointment,
) => {
if (!detectConflict(e.component, appointmentData)) {
setConflictError(false);
return;
}
e.cancel = true;
if (popup?.option('visible')) {
setConflictError(true);
form?.validate();
} else {
const dialog = customDialog({
showTitle: false,
messageHtml: '<p id="conflict-dialog">This time slot conflicts with another appointment.</p>',
buttons: [{
type: 'default',
text: 'Close',
stylingMode: 'contained',
onClick: () => {
dialog.hide();
},
}],
});
dialog.show();
}
};
const onAppointmentAdding = (e: DxSchedulerTypes.AppointmentAddingEvent) => {
handleConflict(e, e.appointmentData as Appointment);
};
const onAppointmentUpdating = (e: DxSchedulerTypes.AppointmentUpdatingEvent) => {
handleConflict(e, { ...e.oldData, ...e.newData } as Appointment);
};
const onFormInitialized = (e: DxFormTypes.InitializedEvent) => {
form = e.component;
e.component!.on('fieldDataChanged', (fieldEvent: { dataField: string }) => {
if (
showConflictError &&
['startDate', 'endDate', 'assigneeId', 'recurrenceRule'].includes(fieldEvent.dataField)
) {
setConflictError(false);
form?.validate();
}
});
};
const customizeItem = (item: DxFormTypes.SimpleItem) => {
if (item.name === 'allDayEditor' || item.name === 'recurrenceEndEditor') {
item.label!.visible = true;
} else if (item.name === 'subjectEditor') {
item.editorOptions = item.editorOptions || {};
item.editorOptions.placeholder = 'Add title';
}
if (item.name === 'startTimeEditor' || item.name === 'endTimeEditor') {
item.validationRules = [
{ type: 'required' },
{
type: 'custom',
message: 'Time conflict',
ignoreEmptyValue: true,
reevaluate: true,
validationCallback: () => !showConflictError,
},
];
}
};
const onOverlappingRuleChanged = (e: DxSelectBoxTypes.ValueChangedEvent) => {
overlappingRule = e.value;
};
</script>
<style>
.dx-scheduler-appointment {
color: #242424;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
gap: 10px;
}
.hide-informer .dx-item:has(.conflict-informer) {
display: none !important;
}
.conflict-informer {
background-color: #FCEAE8;
color: #C50F1F;
font-size: 12px;
padding: 0 12px;
height: 36px;
line-height: 36px;
box-sizing: border-box;
margin-bottom: 8px;
}
.dx-dialog:has(#conflict-dialog) .dx-overlay-content {
width: 280px;
}
.dx-dialog:has(#conflict-dialog) .dx-dialog-content {
padding-bottom: 16px;
}
.dx-dialog:has(#conflict-dialog) .dx-dialog-buttons {
padding-top: 0;
padding-bottom: 16px;
}
.dx-dialog:has(#conflict-dialog) .dx-toolbar-center,
.dx-dialog:has(#conflict-dialog) .dx-button {
width: 100%;
}
.dx-scheduler-form-main-group .dx-item:last-child,
.dx-scheduler-form-main-group .dx-item:last-child .dx-field-item-content,
.dx-scheduler-form-main-group .dx-item:last-child .dx-item:last-child,
.dx-scheduler-form-main-group .dx-item:last-child .dx-item:last-child .dx-field-item-content {
overflow: visible;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export interface Appointment {
id: number;
text: string;
startDate: Date;
endDate: Date;
assigneeId: number[];
recurrenceRule?: string;
allDay?: boolean;
}
export interface Assignee {
id: number;
text: string;
color: string;
}
export const assignees: Assignee[] = [
{ id: 1, text: 'Samantha Bright', color: '#A7E3A5' },
{ id: 2, text: 'John Heart', color: '#CFE4FA' },
{ id: 3, text: 'Todd Hoffman', color: '#F9E2AE' },
{ id: 4, text: 'Sandra Johnson', color: '#F1BBBC' },
];
export const data: Appointment[] = [
{
id: 1,
text: 'Website Re-Design Plan',
startDate: new Date(2026, 1, 9, 9, 30),
endDate: new Date(2026, 1, 9, 11, 30),
assigneeId: [2],
},
{
id: 2,
text: 'Install New Router in Dev Room',
startDate: new Date(2026, 1, 9, 14, 30),
endDate: new Date(2026, 1, 9, 15, 30),
assigneeId: [3],
},
{
id: 3,
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date(2026, 1, 10, 10, 0),
endDate: new Date(2026, 1, 10, 11, 0),
assigneeId: [1],
},
{
id: 4,
text: 'Final Budget Review',
startDate: new Date(2026, 1, 10, 12, 0),
endDate: new Date(2026, 1, 10, 13, 35),
assigneeId: [1],
},
{
id: 5,
text: 'Install New Database',
startDate: new Date(2026, 1, 11, 9, 45),
endDate: new Date(2026, 1, 11, 11, 15),
assigneeId: [4],
},
{
id: 6,
text: 'Approve New Online Marketing Strategy',
startDate: new Date(2026, 1, 11, 12, 0),
endDate: new Date(2026, 1, 11, 14, 0),
assigneeId: [2],
},
{
id: 7,
text: 'Prepare 2021 Marketing Plan',
startDate: new Date(2026, 1, 12, 11, 0),
endDate: new Date(2026, 1, 12, 13, 30),
assigneeId: [3],
},
{
id: 8,
text: 'Brochure Design Review',
startDate: new Date(2026, 1, 12, 14, 0),
endDate: new Date(2026, 1, 12, 15, 30),
assigneeId: [2],
},
{
id: 9,
text: 'Create Icons for Website',
startDate: new Date(2026, 1, 13, 10, 0),
endDate: new Date(2026, 1, 13, 11, 30),
assigneeId: [1],
},
{
id: 10,
text: 'Launch New Website',
startDate: new Date(2026, 1, 13, 12, 20),
endDate: new Date(2026, 1, 13, 14, 0),
assigneeId: [4],
},
{
id: 11,
text: 'Upgrade Server Hardware',
startDate: new Date(2026, 1, 13, 14, 30),
endDate: new Date(2026, 1, 13, 16, 0),
assigneeId: [2],
},
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

import React, {
useCallback, useMemo, useRef,
} from 'react';
import Scheduler, {
Form, Editing, Resource, Item,
} from 'devextreme-react/scheduler';
import type { SchedulerTypes } from 'devextreme-react/scheduler';
import SelectBox from 'devextreme-react/select-box';
import type { SelectBoxTypes } from 'devextreme-react/select-box';
import type { FormTypes } from 'devextreme-react/form';
import type { PopupTypes } from 'devextreme-react/popup';
import type { TagBoxTypes } from 'devextreme-react/tag-box';
import { custom as customDialog } from 'devextreme/ui/dialog';
import { Template } from 'devextreme-react/core/template';
import { data, assignees, type Appointment, type Assignee } from './data.ts';
type dxScheduler = NonNullable<SchedulerTypes.InitializedEvent['component']>;
type dxForm = NonNullable<FormTypes.InitializedEvent['component']>;
type dxPopup = NonNullable<PopupTypes.InitializedEvent['component']>;
const currentDate = new Date(2026, 1, 10);
const views: SchedulerTypes.ViewType[] = ['day', 'week', 'workWeek', 'month'];
const overlappingRuleItems = [
{ value: 'sameResource', text: 'Different Resources' },
{ value: 'allResources', text: 'Never' },
];
function getNextDay(date: Date): Date {
const next = new Date(date);
next.setDate(next.getDate() + 1);
return next;
}
function getEndDate(occurrence: SchedulerTypes.Occurrence): Date {
return (occurrence.appointmentData as Appointment).allDay
? getNextDay(occurrence.startDate)
: occurrence.endDate;
}
function isOverlapping(
a: SchedulerTypes.Occurrence,
b: SchedulerTypes.Occurrence,
overlappingRule: string,
): boolean {
const aEnd = getEndDate(a);
const bEnd = getEndDate(b);
if (a.startDate >= bEnd || b.startDate >= aEnd) return false;
if (overlappingRule === 'sameResource') {
return (a.appointmentData as Appointment).assigneeId[0] === (b.appointmentData as Appointment).assigneeId[0];
}
return true;
}
function detectConflict(
scheduler: dxScheduler,
newAppointment: Appointment,
overlappingRule: string,
): boolean {
const allAppointments = scheduler.getDataSource().items() as Appointment[];
const startDate = new Date(newAppointment.startDate);
let endDate: Date;
if (newAppointment.recurrenceRule) {
endDate = scheduler.getEndViewDate();
} else if (newAppointment.allDay) {
endDate = getNextDay(startDate);
} else {
endDate = new Date(newAppointment.endDate);
}
const existingOccurrences = scheduler
.getOccurrences(startDate, endDate, allAppointments)
.filter((occurrence) => (occurrence.appointmentData as Appointment).id !== newAppointment.id);
const newOccurrences = scheduler.getOccurrences(startDate, endDate, [newAppointment]);
return newOccurrences.some((newOccurrence) =>
existingOccurrences.some((existingOccurrence) =>
isOverlapping(newOccurrence, existingOccurrence, overlappingRule),
),
);
}
const assigneeIdEditorOptions = {
onValueChanged: (e: TagBoxTypes.ValueChangedEvent) => {
if (e.value?.length > 1) {
e.component.option('value', [e.value[e.value.length - 1]]);
}
},
tagTemplate: 'tagTemplate',
};
const tagTemplate = (itemData: Assignee) => (
<div className="dx-tag-content" style={{ backgroundColor: itemData.color, borderColor: itemData.color }}>
{itemData.text}
<div className="dx-tag-remove-button"></div>
</div>
);
const conflictInformerRender = () => (
<div className="conflict-informer">This time slot conflicts with another appointment.</div>
);
const App = () => {
const popupRef = useRef<dxPopup | null>(null);
const formRef = useRef<dxForm | null>(null);
const showConflictErrorRef = useRef(false);
const overlappingRuleRef = useRef('sameResource');
const setConflictError = useCallback((show: boolean) => {
showConflictErrorRef.current = show;
formRef.current?.option('elementAttr.class', show ? '' : 'hide-informer');
}, []);
const handleConflict = useCallback((
e: SchedulerTypes.AppointmentAddingEvent | SchedulerTypes.AppointmentUpdatingEvent,
appointmentData: Appointment,
) => {
if (!detectConflict(e.component, appointmentData, overlappingRuleRef.current)) {
setConflictError(false);
return;
}
e.cancel = true;
if (popupRef.current?.option('visible')) {
setConflictError(true);
formRef.current?.validate();
} else {
const dialog = customDialog({
showTitle: false,
messageHtml: '<p id="conflict-dialog">This time slot conflicts with another appointment.</p>',
buttons: [{
type: 'default',
text: 'Close',
stylingMode: 'contained',
onClick: () => {
dialog.hide();
},
}],
});
dialog.show();
}
}, [setConflictError]);
const onAppointmentAdding = useCallback((e: SchedulerTypes.AppointmentAddingEvent) => {
handleConflict(e, e.appointmentData as Appointment);
}, [handleConflict]);
const onAppointmentUpdating = useCallback((e: SchedulerTypes.AppointmentUpdatingEvent) => {
handleConflict(e, { ...e.oldData, ...e.newData } as Appointment);
}, [handleConflict]);
const popupOptions = useMemo(() => ({
onInitialized: (e: PopupTypes.InitializedEvent) => {
popupRef.current = e.component ?? null;
},
onHidden: () => {
setConflictError(false);
},
}), [setConflictError]);
const onFormInitialized = useCallback((e: FormTypes.InitializedEvent) => {
if (!e.component) return;
formRef.current = e.component;
e.component.on('fieldDataChanged', (fieldEvent: FormTypes.FieldDataChangedEvent) => {
if (
showConflictErrorRef.current &&
['startDate', 'endDate', 'assigneeId', 'recurrenceRule'].includes(fieldEvent.dataField ?? '')
) {
setConflictError(false);
formRef.current?.validate();
}
});
}, [setConflictError]);
const customizeItem = useCallback((item: FormTypes.SimpleItem) => {
if (item.name === 'allDayEditor' || item.name === 'recurrenceEndEditor') {
item.label = { ...item.label, visible: true };
} else if (item.name === 'subjectEditor') {
item.editorOptions = item.editorOptions || {};
item.editorOptions.placeholder = 'Add title';
}
if (item.name === 'startTimeEditor' || item.name === 'endTimeEditor') {
item.validationRules = [
{ type: 'required' },
{
type: 'custom',
message: 'Time conflict',
ignoreEmptyValue: true,
reevaluate: true,
validationCallback: () => !showConflictErrorRef.current,
},
];
}
}, []);
return (
<>
<Scheduler
dataSource={data}
views={views}
defaultCurrentView="week"
defaultCurrentDate={currentDate}
startDayHour={9}
endDayHour={19}
height={600}
showAllDayPanel={false}
allDayPanelMode="hidden"
onAppointmentAdding={onAppointmentAdding}
onAppointmentUpdating={onAppointmentUpdating}
>
<Resource
fieldExpr="assigneeId"
dataSource={assignees}
valueExpr="id"
colorExpr="color"
icon="user"
allowMultiple={true}
/>
<Editing popup={popupOptions}>
<Form
labelMode="hidden"
onInitialized={onFormInitialized}
customizeItem={customizeItem}
elementAttr={{ class: 'hide-informer', id: 'form' }}
>
<Item
name="conflictInformer"
render={conflictInformerRender}
/>
<Item type="group" name="mainGroup">
<Item name="subjectGroup" />
<Item name="dateGroup" />
<Item name="repeatGroup" />
<Item name="assigneeIdGroup">
<Item name="assigneeIdIcon" />
<Item
name="assigneeIdEditor"
isRequired={true}
editorOptions={assigneeIdEditorOptions}
/>
</Item>
</Item>
<Item type="group" name="recurrenceGroup" />
</Form>
</Editing>
<Template name="tagTemplate" render={tagTemplate} />
</Scheduler>
<div className="options">
<div className="option">
<span>Allow Overlapping Appointments</span>
<SelectBox
items={overlappingRuleItems}
valueExpr="value"
displayExpr="text"
defaultValue="sameResource"
onValueChanged={(e: SelectBoxTypes.ValueChangedEvent) => { overlappingRuleRef.current = e.value; }}
/>
</div>
</div>
</>
);
};
export default App;
import React, { useCallback, useMemo, useRef } from 'react';
import Scheduler, {
Form, Editing, Resource, Item,
} from 'devextreme-react/scheduler';
import SelectBox from 'devextreme-react/select-box';
import { custom as customDialog } from 'devextreme/ui/dialog';
import { Template } from 'devextreme-react/core/template';
import { data, assignees } from './data.js';
const currentDate = new Date(2026, 1, 10);
const views = ['day', 'week', 'workWeek', 'month'];
const overlappingRuleItems = [
{ value: 'sameResource', text: 'Different Resources' },
{ value: 'allResources', text: 'Never' },
];
function getNextDay(date) {
const next = new Date(date);
next.setDate(next.getDate() + 1);
return next;
}
function getEndDate(occurrence) {
return occurrence.appointmentData.allDay ? getNextDay(occurrence.startDate) : occurrence.endDate;
}
function isOverlapping(a, b, overlappingRule) {
const aEnd = getEndDate(a);
const bEnd = getEndDate(b);
if (a.startDate >= bEnd || b.startDate >= aEnd) return false;
if (overlappingRule === 'sameResource') {
return a.appointmentData.assigneeId[0] === b.appointmentData.assigneeId[0];
}
return true;
}
function detectConflict(scheduler, newAppointment, overlappingRule) {
const allAppointments = scheduler.getDataSource().items();
const startDate = new Date(newAppointment.startDate);
let endDate;
if (newAppointment.recurrenceRule) {
endDate = scheduler.getEndViewDate();
} else if (newAppointment.allDay) {
endDate = getNextDay(startDate);
} else {
endDate = new Date(newAppointment.endDate);
}
const existingOccurrences = scheduler
.getOccurrences(startDate, endDate, allAppointments)
.filter((occurrence) => occurrence.appointmentData.id !== newAppointment.id);
const newOccurrences = scheduler.getOccurrences(startDate, endDate, [newAppointment]);
return newOccurrences.some((newOccurrence) =>
existingOccurrences.some((existingOccurrence) =>
isOverlapping(newOccurrence, existingOccurrence, overlappingRule),
),
);
}
const assigneeIdEditorOptions = {
onValueChanged: (e) => {
if (e.value?.length > 1) {
e.component.option('value', [e.value[e.value.length - 1]]);
}
},
tagTemplate: 'tagTemplate',
};
const tagTemplate = (itemData) => (
<div
className="dx-tag-content"
style={{ backgroundColor: itemData.color, borderColor: itemData.color }}
>
{itemData.text}
<div className="dx-tag-remove-button"></div>
</div>
);
const conflictInformerRender = () => (
<div className="conflict-informer">This time slot conflicts with another appointment.</div>
);
const App = () => {
const popupRef = useRef(null);
const formRef = useRef(null);
const showConflictErrorRef = useRef(false);
const overlappingRuleRef = useRef('sameResource');
const setConflictError = useCallback((show) => {
showConflictErrorRef.current = show;
formRef.current?.option('elementAttr.class', show ? '' : 'hide-informer');
}, []);
const handleConflict = useCallback(
(e, appointmentData) => {
if (!detectConflict(e.component, appointmentData, overlappingRuleRef.current)) {
setConflictError(false);
return;
}
e.cancel = true;
if (popupRef.current?.option('visible')) {
setConflictError(true);
formRef.current?.validate();
} else {
const dialog = customDialog({
showTitle: false,
messageHtml:
'<p id="conflict-dialog">This time slot conflicts with another appointment.</p>',
buttons: [
{
type: 'default',
text: 'Close',
stylingMode: 'contained',
onClick: () => {
dialog.hide();
},
},
],
});
dialog.show();
}
},
[setConflictError],
);
const onAppointmentAdding = useCallback(
(e) => {
handleConflict(e, e.appointmentData);
},
[handleConflict],
);
const onAppointmentUpdating = useCallback(
(e) => {
handleConflict(e, { ...e.oldData, ...e.newData });
},
[handleConflict],
);
const popupOptions = useMemo(
() => ({
onInitialized: (e) => {
popupRef.current = e.component ?? null;
},
onHidden: () => {
setConflictError(false);
},
}),
[setConflictError],
);
const onFormInitialized = useCallback(
(e) => {
if (!e.component) return;
formRef.current = e.component;
e.component.on('fieldDataChanged', (fieldEvent) => {
if (
showConflictErrorRef.current &&
['startDate', 'endDate', 'assigneeId', 'recurrenceRule'].includes(
fieldEvent.dataField ?? '',
)
) {
setConflictError(false);
formRef.current?.validate();
}
});
},
[setConflictError],
);
const customizeItem = useCallback((item) => {
if (item.name === 'allDayEditor' || item.name === 'recurrenceEndEditor') {
item.label = { ...item.label, visible: true };
} else if (item.name === 'subjectEditor') {
item.editorOptions = item.editorOptions || {};
item.editorOptions.placeholder = 'Add title';
}
if (item.name === 'startTimeEditor' || item.name === 'endTimeEditor') {
item.validationRules = [
{ type: 'required' },
{
type: 'custom',
message: 'Time conflict',
ignoreEmptyValue: true,
reevaluate: true,
validationCallback: () => !showConflictErrorRef.current,
},
];
}
}, []);
return (
<>
<Scheduler
dataSource={data}
views={views}
defaultCurrentView="week"
defaultCurrentDate={currentDate}
startDayHour={9}
endDayHour={19}
height={600}
showAllDayPanel={false}
allDayPanelMode="hidden"
onAppointmentAdding={onAppointmentAdding}
onAppointmentUpdating={onAppointmentUpdating}
>
<Resource
fieldExpr="assigneeId"
dataSource={assignees}
valueExpr="id"
colorExpr="color"
icon="user"
allowMultiple={true}
/>
<Editing popup={popupOptions}>
<Form
labelMode="hidden"
onInitialized={onFormInitialized}
customizeItem={customizeItem}
elementAttr={{ class: 'hide-informer', id: 'form' }}
>
<Item
name="conflictInformer"
render={conflictInformerRender}
/>
<Item
type="group"
name="mainGroup"
>
<Item name="subjectGroup" />
<Item name="dateGroup" />
<Item name="repeatGroup" />
<Item name="assigneeIdGroup">
<Item name="assigneeIdIcon" />
<Item
name="assigneeIdEditor"
isRequired={true}
editorOptions={assigneeIdEditorOptions}
/>
</Item>
</Item>
<Item
type="group"
name="recurrenceGroup"
/>
</Form>
</Editing>
<Template
name="tagTemplate"
render={tagTemplate}
/>
</Scheduler>
<div className="options">
<div className="option">
<span>Allow Overlapping Appointments</span>
<SelectBox
items={overlappingRuleItems}
valueExpr="value"
displayExpr="text"
defaultValue="sameResource"
onValueChanged={(e) => {
overlappingRuleRef.current = e.value;
}}
/>
</div>
</div>
</>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export interface Appointment {
id: number;
text: string;
startDate: Date;
endDate: Date;
assigneeId: number[];
recurrenceRule?: string;
allDay?: boolean;
}
export interface Assignee {
id: number;
text: string;
color: string;
}
export const assignees: Assignee[] = [
{ id: 1, text: 'Samantha Bright', color: '#A7E3A5' },
{ id: 2, text: 'John Heart', color: '#CFE4FA' },
{ id: 3, text: 'Todd Hoffman', color: '#F9E2AE' },
{ id: 4, text: 'Sandra Johnson', color: '#F1BBBC' },
];
export const data: Appointment[] = [
{
id: 1,
text: 'Website Re-Design Plan',
startDate: new Date(2026, 1, 9, 9, 30),
endDate: new Date(2026, 1, 9, 11, 30),
assigneeId: [2],
},
{
id: 2,
text: 'Install New Router in Dev Room',
startDate: new Date(2026, 1, 9, 14, 30),
endDate: new Date(2026, 1, 9, 15, 30),
assigneeId: [3],
},
{
id: 3,
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date(2026, 1, 10, 10, 0),
endDate: new Date(2026, 1, 10, 11, 0),
assigneeId: [1],
},
{
id: 4,
text: 'Final Budget Review',
startDate: new Date(2026, 1, 10, 12, 0),
endDate: new Date(2026, 1, 10, 13, 35),
assigneeId: [1],
},
{
id: 5,
text: 'Install New Database',
startDate: new Date(2026, 1, 11, 9, 45),
endDate: new Date(2026, 1, 11, 11, 15),
assigneeId: [4],
},
{
id: 6,
text: 'Approve New Online Marketing Strategy',
startDate: new Date(2026, 1, 11, 12, 0),
endDate: new Date(2026, 1, 11, 14, 0),
assigneeId: [2],
},
{
id: 7,
text: 'Prepare 2021 Marketing Plan',
startDate: new Date(2026, 1, 12, 11, 0),
endDate: new Date(2026, 1, 12, 13, 30),
assigneeId: [3],
},
{
id: 8,
text: 'Brochure Design Review',
startDate: new Date(2026, 1, 12, 14, 0),
endDate: new Date(2026, 1, 12, 15, 30),
assigneeId: [2],
},
{
id: 9,
text: 'Create Icons for Website',
startDate: new Date(2026, 1, 13, 10, 0),
endDate: new Date(2026, 1, 13, 11, 30),
assigneeId: [1],
},
{
id: 10,
text: 'Launch New Website',
startDate: new Date(2026, 1, 13, 12, 20),
endDate: new Date(2026, 1, 13, 14, 0),
assigneeId: [4],
},
{
id: 11,
text: 'Upgrade Server Hardware',
startDate: new Date(2026, 1, 13, 14, 30),
endDate: new Date(2026, 1, 13, 16, 0),
assigneeId: [2],
},
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const assignees = [
{ id: 1, text: 'Samantha Bright', color: '#A7E3A5' },
{ id: 2, text: 'John Heart', color: '#CFE4FA' },
{ id: 3, text: 'Todd Hoffman', color: '#F9E2AE' },
{ id: 4, text: 'Sandra Johnson', color: '#F1BBBC' },
];
export const data = [
{
id: 1,
text: 'Website Re-Design Plan',
startDate: new Date(2026, 1, 9, 9, 30),
endDate: new Date(2026, 1, 9, 11, 30),
assigneeId: [2],
},
{
id: 2,
text: 'Install New Router in Dev Room',
startDate: new Date(2026, 1, 9, 14, 30),
endDate: new Date(2026, 1, 9, 15, 30),
assigneeId: [3],
},
{
id: 3,
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date(2026, 1, 10, 10, 0),
endDate: new Date(2026, 1, 10, 11, 0),
assigneeId: [1],
},
{
id: 4,
text: 'Final Budget Review',
startDate: new Date(2026, 1, 10, 12, 0),
endDate: new Date(2026, 1, 10, 13, 35),
assigneeId: [1],
},
{
id: 5,
text: 'Install New Database',
startDate: new Date(2026, 1, 11, 9, 45),
endDate: new Date(2026, 1, 11, 11, 15),
assigneeId: [4],
},
{
id: 6,
text: 'Approve New Online Marketing Strategy',
startDate: new Date(2026, 1, 11, 12, 0),
endDate: new Date(2026, 1, 11, 14, 0),
assigneeId: [2],
},
{
id: 7,
text: 'Prepare 2021 Marketing Plan',
startDate: new Date(2026, 1, 12, 11, 0),
endDate: new Date(2026, 1, 12, 13, 30),
assigneeId: [3],
},
{
id: 8,
text: 'Brochure Design Review',
startDate: new Date(2026, 1, 12, 14, 0),
endDate: new Date(2026, 1, 12, 15, 30),
assigneeId: [2],
},
{
id: 9,
text: 'Create Icons for Website',
startDate: new Date(2026, 1, 13, 10, 0),
endDate: new Date(2026, 1, 13, 11, 30),
assigneeId: [1],
},
{
id: 10,
text: 'Launch New Website',
startDate: new Date(2026, 1, 13, 12, 20),
endDate: new Date(2026, 1, 13, 14, 0),
assigneeId: [4],
},
{
id: 11,
text: 'Upgrade Server Hardware',
startDate: new Date(2026, 1, 13, 14, 30),
endDate: new Date(2026, 1, 13, 16, 0),
assigneeId: [2],
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-scheduler-appointment {
color: #242424;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
gap: 10px;
}
.hide-informer .dx-item:has(.conflict-informer) {
display: none !important;
}
.conflict-informer {
background-color: #FCEAE8;
color: #C50F1F;
font-size: 12px;
padding: 0 12px;
height: 36px;
line-height: 36px;
box-sizing: border-box;
margin-bottom: 8px;
}
.dx-dialog:has(#conflict-dialog) .dx-overlay-content {
width: 280px;
}
.dx-dialog:has(#conflict-dialog) .dx-dialog-content {
padding-bottom: 16px;
}
.dx-dialog:has(#conflict-dialog) .dx-dialog-buttons {
padding-top: 0;
padding-bottom: 16px;
}
.dx-dialog:has(#conflict-dialog) .dx-toolbar-center,
.dx-dialog:has(#conflict-dialog) .dx-button {
width: 100%;
}

<dx-scheduler
[dataSource]="appointmentsData"
[views]="views"
currentView="week"
[startDayHour]="9"
[endDayHour]="19"
[currentDate]="currentDate"
[height]="600"
[showAllDayPanel]="false"
allDayPanelMode="hidden"
(onAppointmentAdding)="onAppointmentAdding($event)"
(onAppointmentUpdating)="onAppointmentUpdating($event)"
>
<dxi-scheduler-resource
fieldExpr="assigneeId"
[dataSource]="assignees"
valueExpr="id"
colorExpr="color"
icon="user"
[allowMultiple]="true"
></dxi-scheduler-resource>
<dxo-scheduler-editing [popup]="popupOptions">
<dxo-scheduler-form
labelMode="hidden"
[elementAttr]="formElementAttr"
[customizeItem]="customizeItem"
[onInitialized]="onFormInitialized"
>
<dxi-scheduler-item
name="conflictInformer"
template="conflictInformerTemplate"
></dxi-scheduler-item>
<dxi-scheduler-item name="mainGroup" itemType="group">
<dxi-scheduler-item name="subjectGroup"></dxi-scheduler-item>
<dxi-scheduler-item name="dateGroup"></dxi-scheduler-item>
<dxi-scheduler-item name="repeatGroup"></dxi-scheduler-item>
<dxi-scheduler-item name="assigneeIdGroup">
<dxi-scheduler-item name="assigneeIdIcon"></dxi-scheduler-item>
<dxi-scheduler-item
name="assigneeIdEditor"
[isRequired]="true"
[editorOptions]="assigneeIdEditorOptions"
></dxi-scheduler-item>
</dxi-scheduler-item>
</dxi-scheduler-item>
<dxi-scheduler-item
name="recurrenceGroup"
itemType="group"
></dxi-scheduler-item>
</dxo-scheduler-form>
</dxo-scheduler-editing>
<div *dxTemplate="let _ of 'conflictInformerTemplate'">
<div class="conflict-informer"
>This time slot conflicts with another appointment.</div
>
</div>
<div *dxTemplate="let tagData of 'assigneeTagTemplate'">
<div
class="dx-tag-content"
[style.background-color]="tagData.color"
[style.border-color]="tagData.color"
>
<span>{{ tagData.text }}</span>
<div class="dx-tag-remove-button"></div>
</div>
</div>
</dx-scheduler>
<div class="options">
<div class="option">
<span>Allow Overlapping Appointments</span>
<dx-select-box
[items]="overlappingRuleItems"
valueExpr="value"
displayExpr="text"
value="sameResource"
(onValueChanged)="onOverlappingRuleChanged($event)"
></dx-select-box>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxSchedulerModule, DxSelectBoxModule, DxTemplateModule } from 'devextreme-angular';
import { DxSchedulerTypes } from 'devextreme-angular/ui/scheduler';
import { DxSelectBoxTypes } from 'devextreme-angular/ui/select-box';
import { DxFormTypes } from 'devextreme-angular/ui/form';
import { DxPopupTypes } from 'devextreme-angular/ui/popup';
import { DxTagBoxTypes } from 'devextreme-angular/ui/tag-box';
import { custom as customDialog } from 'devextreme/ui/dialog';
import { Appointment, Assignee, Service, assignees } from './app.service';
type dxScheduler = NonNullable<DxSchedulerTypes.InitializedEvent['component']>;
type dxForm = NonNullable<DxFormTypes.InitializedEvent['component']>;
type dxPopup = NonNullable<DxPopupTypes.InitializedEvent['component']>;
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
imports: [
DxSchedulerModule,
DxSelectBoxModule,
DxTemplateModule,
],
})
export class AppComponent {
appointmentsData: Appointment[];
currentDate: Date = new Date(2026, 1, 10);
views: DxSchedulerTypes.ViewType[] = ['day', 'week', 'workWeek', 'month'];
assignees: Assignee[] = assignees;
overlappingRuleItems = [
{ value: 'sameResource', text: 'Different Resources' },
{ value: 'allResources', text: 'Never' },
];
assigneeIdEditorOptions = {
onValueChanged: (e: DxTagBoxTypes.ValueChangedEvent) => {
if (e.value?.length > 1) {
e.component.option('value', [e.value[e.value.length - 1]]);
}
},
tagTemplate: 'assigneeTagTemplate',
};
popupOptions = {
onInitialized: (e: DxPopupTypes.InitializedEvent) => { this.popup = e.component; },
onHidden: () => {
this.setConflictError(false);
},
};
formElementAttr = { id: 'form', class: 'hide-informer' };
private popup?: dxPopup;
private form?: dxForm;
private overlappingRule = 'sameResource';
constructor(service: Service) {
this.appointmentsData = service.getAppointments();
}
private showConflictError = false;
setConflictError(show: boolean): void {
this.showConflictError = show;
this.form?.option('elementAttr.class', show ? '' : 'hide-informer');
}
onFormInitialized = (e: DxFormTypes.InitializedEvent): void => {
this.form = e.component;
this.form?.on('fieldDataChanged', (event: { dataField: string }) => {
if (this.showConflictError && ['startDate', 'endDate', 'assigneeId', 'recurrenceRule'].includes(event.dataField)) {
this.setConflictError(false);
this.form?.validate();
}
});
};
customizeItem = (item: DxFormTypes.SimpleItem): void => {
if (item.name === 'allDayEditor' || item.name === 'recurrenceEndEditor') {
item.label.visible = true;
} else if (item.name === 'subjectEditor') {
item.editorOptions = item.editorOptions || {};
item.editorOptions.placeholder = 'Add title';
}
if (item.name === 'startTimeEditor' || item.name === 'endTimeEditor') {
item.validationRules = [
{ type: 'required' },
{
type: 'custom',
message: 'Time conflict',
ignoreEmptyValue: true,
reevaluate: true,
validationCallback: () => !this.showConflictError,
},
];
}
};
private getNextDay(date: Date): Date {
const next = new Date(date);
next.setDate(next.getDate() + 1);
return next;
}
private getEndDate(occurrence: DxSchedulerTypes.Occurrence): Date {
return (occurrence.appointmentData as Appointment).allDay
? this.getNextDay(occurrence.startDate)
: occurrence.endDate;
}
private isOverlapping(a: DxSchedulerTypes.Occurrence, b: DxSchedulerTypes.Occurrence): boolean {
const aEnd = this.getEndDate(a);
const bEnd = this.getEndDate(b);
if (a.startDate >= bEnd || b.startDate >= aEnd) return false;
if (this.overlappingRule === 'sameResource') {
return (a.appointmentData as Appointment).assigneeId[0] === (b.appointmentData as Appointment).assigneeId[0];
}
return true;
}
private detectConflict(scheduler: dxScheduler, newAppointment: Appointment): boolean {
const allAppointments = scheduler.getDataSource().items() as Appointment[];
const startDate = new Date(newAppointment.startDate);
let endDate: Date;
if (newAppointment.recurrenceRule) {
endDate = scheduler.getEndViewDate();
} else if (newAppointment.allDay) {
endDate = this.getNextDay(startDate);
} else {
endDate = new Date(newAppointment.endDate);
}
const existingOccurrences = scheduler
.getOccurrences(startDate, endDate, allAppointments)
.filter((occurrence) => (occurrence.appointmentData as Appointment).id !== newAppointment.id);
const newOccurrences = scheduler.getOccurrences(startDate, endDate, [newAppointment]);
return newOccurrences.some((newOccurrence) =>
existingOccurrences.some((existingOccurrence) =>
this.isOverlapping(newOccurrence, existingOccurrence),
),
);
}
private handleConflict(
e: DxSchedulerTypes.AppointmentAddingEvent | DxSchedulerTypes.AppointmentUpdatingEvent,
appointmentData: Appointment,
): void {
if (!this.detectConflict(e.component, appointmentData)) {
this.setConflictError(false);
return;
}
e.cancel = true;
if (this.popup?.option('visible')) {
this.setConflictError(true);
this.form?.validate();
} else {
const dialog = customDialog({
showTitle: false,
messageHtml: '<p id="conflict-dialog">This time slot conflicts with another appointment.</p>',
buttons: [{
type: 'default',
text: 'Close',
stylingMode: 'contained',
onClick: () => {
dialog.hide();
},
}],
});
dialog.show();
}
}
onAppointmentAdding(e: DxSchedulerTypes.AppointmentAddingEvent): void {
this.handleConflict(e, e.appointmentData as Appointment);
}
onAppointmentUpdating(e: DxSchedulerTypes.AppointmentUpdatingEvent): void {
this.handleConflict(e, { ...e.oldData, ...e.newData } as Appointment);
}
onOverlappingRuleChanged(e: DxSelectBoxTypes.ValueChangedEvent): void {
this.overlappingRule = e.value;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .dx-scheduler-appointment {
color: #242424;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
gap: 10px;
}
::ng-deep .hide-informer .dx-item:has(.conflict-informer) {
display: none !important;
}
::ng-deep .conflict-informer {
background-color: #FCEAE8;
color: #C50F1F;
font-size: 12px;
padding: 0 12px;
height: 36px;
line-height: 36px;
box-sizing: border-box;
margin-bottom: 8px;
}
::ng-deep .dx-dialog:has(#conflict-dialog) .dx-overlay-content {
width: 280px;
}
::ng-deep .dx-dialog:has(#conflict-dialog) .dx-dialog-content {
padding-bottom: 16px;
}
::ng-deep .dx-dialog:has(#conflict-dialog) .dx-dialog-buttons {
padding-top: 0;
padding-bottom: 16px;
}
::ng-deep .dx-dialog:has(#conflict-dialog) .dx-toolbar-center,
::ng-deep .dx-dialog:has(#conflict-dialog) .dx-button {
width: 100%;
}
import { Injectable } from '@angular/core';
export interface Appointment {
id: number;
text: string;
startDate: Date;
endDate: Date;
assigneeId: number[];
recurrenceRule?: string;
allDay?: boolean;
}
export interface Assignee {
id: number;
text: string;
color: string;
}
export const assignees: Assignee[] = [
{ id: 1, text: 'Samantha Bright', color: '#A7E3A5' },
{ id: 2, text: 'John Heart', color: '#CFE4FA' },
{ id: 3, text: 'Todd Hoffman', color: '#F9E2AE' },
{ id: 4, text: 'Sandra Johnson', color: '#F1BBBC' },
];
const appointments: Appointment[] = [
{
id: 1,
text: 'Website Re-Design Plan',
startDate: new Date(2026, 1, 9, 9, 30),
endDate: new Date(2026, 1, 9, 11, 30),
assigneeId: [2],
},
{
id: 2,
text: 'Install New Router in Dev Room',
startDate: new Date(2026, 1, 9, 14, 30),
endDate: new Date(2026, 1, 9, 15, 30),
assigneeId: [3],
},
{
id: 3,
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date(2026, 1, 10, 10, 0),
endDate: new Date(2026, 1, 10, 11, 0),
assigneeId: [1],
},
{
id: 4,
text: 'Final Budget Review',
startDate: new Date(2026, 1, 10, 12, 0),
endDate: new Date(2026, 1, 10, 13, 35),
assigneeId: [1],
},
{
id: 5,
text: 'Install New Database',
startDate: new Date(2026, 1, 11, 9, 45),
endDate: new Date(2026, 1, 11, 11, 15),
assigneeId: [4],
},
{
id: 6,
text: 'Approve New Online Marketing Strategy',
startDate: new Date(2026, 1, 11, 12, 0),
endDate: new Date(2026, 1, 11, 14, 0),
assigneeId: [2],
},
{
id: 7,
text: 'Prepare 2021 Marketing Plan',
startDate: new Date(2026, 1, 12, 11, 0),
endDate: new Date(2026, 1, 12, 13, 30),
assigneeId: [3],
},
{
id: 8,
text: 'Brochure Design Review',
startDate: new Date(2026, 1, 12, 14, 0),
endDate: new Date(2026, 1, 12, 15, 30),
assigneeId: [2],
},
{
id: 9,
text: 'Create Icons for Website',
startDate: new Date(2026, 1, 13, 10, 0),
endDate: new Date(2026, 1, 13, 11, 30),
assigneeId: [1],
},
{
id: 10,
text: 'Launch New Website',
startDate: new Date(2026, 1, 13, 12, 20),
endDate: new Date(2026, 1, 13, 14, 0),
assigneeId: [4],
},
{
id: 11,
text: 'Upgrade Server Hardware',
startDate: new Date(2026, 1, 13, 14, 30),
endDate: new Date(2026, 1, 13, 16, 0),
assigneeId: [2],
},
];
@Injectable()
export class Service {
getAppointments(): Appointment[] {
return appointments;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>